/* 2011-10-18: File added by Sony Corporation */
/*
 *  arch/arm/mach-xarina/clock.h
 *
 *  Copyright 2010-2011 Sony Corporation
 *  Copyright (C) 2004 ARM Limited.
 *  Written by Deep Blue Solutions Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
struct module;

struct clk {
	unsigned long		rate;
};

#if defined(CONFIG_MACH_XARINA_EVB)
#define XARINA_UART_CLK		12500000	/* 12.5 MHz */
#define XARINA_WDT_CLK		1000000		/* 1 MHz */
#define XARINA_SPI_CLK		50000000	/* 50 MHz */
#elif defined(CONFIG_MACH_XARINA_FPGA)
#define XARINA_UART_CLK		3375000		/* 3.375 MHz */
#define XARINA_WDT_CLK		1000000		/* 1 MHz */
#define XARINA_SPI_CLK		13500000	/* 13.5 MHz */
#else
#error "Unknown board type"
#endif

int clk_register(struct clk *clk);
void clk_unregister(struct clk *clk);

