/* 2011-10-18: File added by Sony Corporation */
/*
 *  arch/arm/mach-xarina/core.h
 *
 *  Copyright 2010-2011 Sony Corporation
 *  Copyright (C) 2004 ARM Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_ARCH_XARINA_H
#define __ASM_ARCH_XARINA_H

#include <linux/amba/bus.h>

#define AMBA_DEVICE(name,busid,base,plat)			\
static struct amba_device name##_device = {			\
	.dev		= {					\
		.coherent_dma_mask = ~0,			\
		.init_name = busid,				\
		.platform_data = plat,				\
	},							\
	.res		= {					\
		.start	= XARINA_##base##_PHYS_BASE,		\
		.end	= (XARINA_##base##_PHYS_BASE) + SZ_4K - 1,		\
		.flags	= IORESOURCE_MEM,			\
	},							\
	.dma_mask	= ~0,					\
	.irq		= base##_IRQ,				\
	/* .dma		= base##_DMA,*/				\
}

/* struct mtd_partition */
#define MTD_PART(nm,of,sz) { \
	.name		= nm, \
	.offset		= of, \
	.size		= sz, \
	.mask_flags	= 0, \
}

struct machine_desc;
struct amba_device;
struct platform_device;
struct xarina_pinmux;

extern void __init xarina_init(struct xarina_pinmux *pinmux);
extern void __init xarina_ambadev_register(struct amba_device *adev, bool pinmux);
extern void __init xarina_platdev_register(struct platform_device *pdev, bool pinmux);
extern void __init xarina_init_irq(void);
extern void __init xarina_map_io(void);
extern struct sys_timer sp804_sys_timer;

#endif
