/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#include <linux/init.h>
#include <linux/module.h>
#include <asm/dma.h>
#include <asm/mach/dma.h>

static int dummy_pl080_request_dma(unsigned int channel, dma_t *dma)
{
	return -EBUSY;
}

struct dma_struct pl080_isa_dma[DMAC_ISA_CH_MAX];
static struct dma_ops dummy_pl080_dma_ops = {
	.type		= "PL080R16_DMAC",
	.request	= dummy_pl080_request_dma,
};


EXPORT_SYMBOL(pl080_isa_dma);

static int __init xarina_dma_init(void)
{
	int ret;
	int i;

	/* register DMAC */
	for (i=0; i<DMAC_ISA_CH_MAX; i++) {
		pl080_isa_dma[i].d_ops = &dummy_pl080_dma_ops;
		ret = isa_dma_add(i, &pl080_isa_dma[i]);
		if (ret) {
			printk(KERN_ERR "dma ch%d unable to register: %d\n", i, ret);
			return ret;
		}
	}

	return 0;
}

core_initcall(xarina_dma_init);
