/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Low-level IRQ helper macros
 *
 *  Copyright 2010, 2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#include <asm/hardware/vic.h>
#include <mach/platform.h>

		.macro	disable_fiq
		.endm

		.macro	get_irqnr_preamble, base, tmp
		ldr	\base, =(XARINA_VIC1_VIRT_BASE)
		.endm

		.macro  arch_ret_to_user, tmp1, tmp2
		.endm

		/* linux-2.6.17/include/asm-arm/arch-ep93xx/entry-macro.S be used as reference */
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
		ldr     \base, =(XARINA_VIC1_VIRT_BASE)
		mov     \irqnr, #0
		ldr     \irqstat, [\base, #VIC_IRQ_STATUS]              @ lower 32 interrupts
		cmp     \irqstat, #0
		bne     1001f

		ldr     \base, =(XARINA_VIC2_VIRT_BASE)
		ldr     \irqstat, [\base, #VIC_IRQ_STATUS]              @ upper 32 interrupts
		cmp     \irqstat, #0
		beq     1002f
		mov     \irqnr, #0x20

1001:
		movs    \tmp, \irqstat, lsl #16
		movne   \irqstat, \tmp
		addeq   \irqnr, \irqnr, #16

		movs    \tmp, \irqstat, lsl #8
		movne   \irqstat, \tmp
		addeq   \irqnr, \irqnr, #8

		movs    \tmp, \irqstat, lsl #4
		movne   \irqstat, \tmp
		addeq   \irqnr, \irqnr, #4

		movs    \tmp, \irqstat, lsl #2
		movne   \irqstat, \tmp
		addeq   \irqnr, \irqnr, #2

		movs    \tmp, \irqstat, lsl #1
		addeq   \irqnr, \irqnr, #1
		orrs    \base, \base, #1

1002:
		.endm

