/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef __ASM_ARCH_SDIF_H
#define __ASM_ARCH_SDIF_H

#if defined(CONFIG_MACH_XARINA_FPGA)
/* for Vendor Specific Register */
#define SDIF_V18SUP_C			(1 << 26)
#define SDIF_V30SUP_C			(1 << 25)
#define SDIF_V33SUP_C			(1 << 24)
#define SDIF_SUSSUP_C			(1 << 23)
#define SDIF_DMASUP_C			(1 << 22)
#define SDIF_HSPSUP_C			(1 << 21)
#define SDIF_ADMA1SUP_C			(1 << 20)
#define SDIF_ADMA2SUP_C			(1 << 19)
#define SDIF_MMC4_SUP_C 		(1 << 18)
#define SDIF_BASE_FREQ_C		(0xE << 8)	/* 14 MHz */
#define SDIF_TMO_UNIT_C			(1 << 7)
#define SDIF_TMO_FREQ_C			(0xE << 0)	/* 14 MHz */
#define SDIF_CAPABILITIES_CONTROL	(SDIF_V18SUP_C  \
					| SDIF_V30SUP_C \
					| SDIF_V33SUP_C \
					| SDIF_SUSSUP_C \
					| SDIF_DMASUP_C \
					| SDIF_HSPSUP_C \
					| SDIF_ADMA1SUP_C \
					| SDIF_ADMA2SUP_C \
					| SDIF_MMC4_SUP_C \
					| SDIF_BASE_FREQ_C \
					| SDIF_TMO_UNIT_C \
					| SDIF_TMO_FREQ_C)

#define SDIF_SD_AMBA_CTL0_VAL		0x2	/* INCR16 */
#define SDIF_SD_AMBA_CTL1_VAL		0x0	/* not inserted */
#define SDIF_SD_CAP_CTL_VAL		SDIF_CAPABILITIES_CONTROL
#define SDIF_SD_MAXC_CTL_VAL		0x0	/* Get information via another method */
#define SDIF_SD_CEATA_CAP_CTL_VAL	(1 << 4)	/* CE-ATA Supported */
#define SDIF_SD_CLK_DLY_CTL_VAL		0x3	/* sdclko + 3Buffer Delay */

#elif defined(CONFIG_MACH_XARINA_EVB)
/* for Vendor Specific Register */
#define SDIF_V18SUP_C			(1 << 26)
#define SDIF_V30SUP_C			(1 << 25)
#define SDIF_V33SUP_C			(1 << 24)
#define SDIF_SUSSUP_C			(1 << 23)
#define SDIF_DMASUP_C			(1 << 22)
#define SDIF_HSPSUP_C			(1 << 21)
#define SDIF_ADMA1SUP_C			(1 << 20)
#define SDIF_ADMA2SUP_C			(1 << 19)
#define SDIF_MMC4_SUP_C 		(1 << 18)
#define SDIF_BASE_FREQ_C		(0x28 << 8)	/* 40 MHz */
#define SDIF_TMO_UNIT_C			(1 << 7)
#define SDIF_TMO_FREQ_C			(0x28 << 0)	/* 40 MHz */
#define SDIF_CAPABILITIES_CONTROL	(SDIF_V18SUP_C  \
					| SDIF_V30SUP_C \
					| SDIF_V33SUP_C \
					| SDIF_SUSSUP_C \
					| SDIF_DMASUP_C \
					| SDIF_HSPSUP_C \
					| SDIF_ADMA1SUP_C \
					| SDIF_ADMA2SUP_C \
					| SDIF_MMC4_SUP_C \
					| SDIF_BASE_FREQ_C \
					| SDIF_TMO_UNIT_C \
					| SDIF_TMO_FREQ_C)

#define SDIF_SD_AMBA_CTL0_VAL		0x2	/* INCR16 */
#define SDIF_SD_AMBA_CTL1_VAL		0x0	/* not inserted */
#define SDIF_SD_CAP_CTL_VAL		SDIF_CAPABILITIES_CONTROL
#define SDIF_SD_MAXC_CTL_VAL		0x0	/* Get information via another method */
#define SDIF_SD_CEATA_CAP_CTL_VAL	(1 << 4)	/* CE-ATA Supported */
#define SDIF_SD_CLK_DLY_CTL_VAL		0x3	/* sdclko + 3Buffer Delay */
#else
#error "Unknown board type"
#endif

#endif

