/* 2011-10-18: File added by Sony Corporation */
/*
 *  arch/arm/mach-xarina/include/mach/system.h
 *
 *  Copyright 2010-2011 Sony Corporation
 *  Copyright (C) 2003 ARM Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <linux/spinlock.h>
#include <mach/hardware.h>
#include <asm/io.h>
#include <mach/platform.h>

static inline void arch_idle(void)
{
	/*
	 * This should do all the clock switching
	 * and wait for interrupt tricks
	 */
	cpu_do_idle();
}

static inline void arch_reset(char mode, const char *cmd)
{
	spinlock_t lock;
	unsigned long flags;

	spin_lock_init(&lock);

	spin_lock_irqsave(&lock, flags);

#define SP805_LOAD	0x00
#define SP805_CTRL	0x08
#define SP805_LOCK	0xC00
	/* enable write access to all other registers */
	__raw_writel(0x1ACCE551, XARINA_WDT1_VIRT_BASE + SP805_LOCK);
	/* enable the interrupt event and enable Watchdog module reset output */
	__raw_writel(0x3, XARINA_WDT1_VIRT_BASE + SP805_CTRL);
	/* immediately restart */
	__raw_writel(0x1, XARINA_WDT1_VIRT_BASE + SP805_LOAD);

	spin_unlock_irqrestore(&lock, flags);
}

#endif
