/* 2011-10-03: File added and changed by Sony Corporation */
/*
 *  Copyright 2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef __MACH_XARINA_SYSREG_H
#define __MACH_XARINA_SYSREG_H

#include <linux/init.h>
#include <linux/types.h>
#include <mach/xarina_sysreg1.h>

struct xarina_pinmux {
	/* true if using pinmux settings */
	bool enable;

	/* set 1 if you use its bit(port) */
	u8 gpioa;
	u8 gpiob;
	u8 gpioc;
	u8 gpioe;
	u8 gpiof;
	u8 gpiog;
	u8 gpioh;
	u8 gpioi;

	/* set true if pinmux select */
	bool spi2;
	bool spi3;
	bool uart0;
	bool uart1;
	bool uart2;
	bool uart3;
	bool sd;
	bool pwm0;
	bool pwm1;

	/* # of nand chips */
	int nand_nr;
};

enum xarina_board_t {
	XARINA_UNKNOWN_BOARD = -1,
	XARINA_EVB_BOARD = 1,
	XARINA_RD_BOARD,
};

bool __init xarina_is_connect_jtag(void);
bool __init xarina_is_nand1(void);
enum xarina_board_t xarina_board_type(void);
bool __init xarina_is_mii(void);
void __init xarina_sysreg_init(struct xarina_pinmux* pinmux);

#endif

