/* 2012-04-06: File added by Sony Corporation */
/*
 * arch/arm/mach-xarina/usb/mach-usb_suh_dbg.h
 *
 * the init programs for debug of usb_suh.
 *
 * Copyright 2012 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */
#ifndef _MACH_USB_SCD_DBG_H_
#define _MACH_USB_SCD_DBG_H_

extern int suh_debug_level;

#if SUH_DEBUG > 0

#define _if_dbg_level(level) \
	if ( (level>=-1 && suh_debug_level>=level) || suh_debug_level==level )
#define xprintk(level, facility, format, args...) \
        do { _if_dbg_level(level) { \
                printk(facility "%s %d: " format , \
                       __FUNCTION__, __LINE__ , ## args); \
        } } while (0)
#define xprintks(level, format, args...) \
        do { _if_dbg_level(level) { printk(format,  ## args); } } while (0)

#define DBG(level,fmt,args...) xprintk(level,KERN_INFO,fmt, ## args)
#define DBGS(level,fmt,args...) xprintks(level, fmt, ## args)
#define ERR(fmt,args...) xprintk(-1,KERN_INFO,fmt, ## args)
#define INFO(fmt,args...) xprintk(-1,KERN_INFO,fmt, ## args)

#else

#define DBG(fmt,args...)	do {}  while (0)
#define DBGS(fmt,args...)	do {}  while (0)
#define ERR(fmt,args...)  	do {}  while (0)
#define INFO(fmt,args...) 	do {}  while (0)

#endif	/* SUH_DEBUG */
#endif	/* _MACH_USB_SUH_DBG_H_ */

