/* 2012-03-12: File added and changed by Sony Corporation */
/*
 * linux/arch/arm/mach-xarina/include/mach/suh_defs.h
 *
 * the init programs for the clock operation of usb_suh.
 *
 * Copyright 2012 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#include <linux/bitops.h>

/* USBH_RESET */
#define XARINA_USBH_SYSREG_INT		0x00
#define XARINA_USBH_SYSREG_INT_MSK	0x04
#define XARINA_USBH_SYSREG_RESET	0x10
#define XARINA_USBH_SYSREG_REVISION	0x28

#define XARINA_USBH_B_INT_RESET		BIT(0)
#define XARINA_USBH_B_RESET_MSK		BIT(0)
#define XARINA_USBH_B_RESET		BIT(0)
#define XARINA_USBH_B_RESUME		BIT(1)

#define XARINA_USBH_REVISION		0x296A

/* Polarity setting */
#define XARINA_USBH_SYSREG_POLARITY_SET	0x18
#define XARINA_USBH_B_VBUSENPOL		BIT(1)
#define XARINA_USBH_B_OCPOL		BIT(0)

#define XARINA_USB_SYTREG_IRQ_ID	"xarina_reset_irq"

/* sysreg1 define */
#define XARINA_SYSREG1_PLL_READY_PLL5_SFT	4

/* PLL5 Frequency value */
#define XARINA_SYSREG1_PLL5_CTRL_USBCLK_24MHZ	0x000B5F12
#define XARINA_SYSREG1_PLL5_FRQ		XARINA_SYSREG1_PLL5_CTRL_USBCLK_24MHZ

/* Please adjust a value based on system clock specification, if needed.*/
#define XARINA_USB_CLK_PLL_RDY_WAIT	100	/* 100us */
#define	XARINA_USB_MAX_WAIT_CNT_PLL5	10	/* loop count */

/* please describe the information for HW */
#define OHCI_SUH_UHP_BASE XARINA_USBH_OHCI_PHYS_BASE
#define OHCI_SUH_ID_UHP		IRQ_USBH_OHCI

#define EHCI_SUH_UHP_BASE XARINA_USBH_EHCI_PHYS_BASE
#define EHCI_SUH_ID_UHP		IRQ_USBH_EHCI

#define USBH_SYSREG_BASE XARINA_USBH_SYSREG_PHYS_BASE
#define USBH_SYSREG_ID		IRQ_USBH_SYSCTRL

#define OHCI_SUH_SZ		0x200
#define EHCI_SUH_SZ		0x400
#define USBH_SYSREG_SZ		0x1000

#define RSC_MEM_IND		0
#define RSC_IRQ_IND		1

