/* 2013-07-22: File added and changed by Sony Corporation */
/*
 * Copyright 2013 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#include "hal_cmd.h"

/*==============================================================
         DES64 Functions
==============================================================*/

/******************************************************
Initialize DES
*******************************************************/
void de_Init_Des(void)
{
    *p_de64n_INIT_0 = 0x00000000;
}

/******************************************************
Write 64bits of data into normal register
*******************************************************/
void de64_Write_Idata(const void* pInData)
{
    *p_de64n_INPUT_DATA1 = ((uint32_t *)pInData)[0];
    *p_de64n_INPUT_DATA0 = ((uint32_t *)pInData)[1];
}

/******************************************************
Set IV
*******************************************************/
void de64_Set_Iv(const void* pInData)
{
    de64_Write_Idata(pInData);
    *p_de64n_SET_IV = 0x00000000;
}

/******************************************************
Set Key2 for DES-CBC
*******************************************************/
void de_Set_K2(void)
{
    *p_de64n_SET_K2 = 0x00000000;
}

/******************************************************
DES-CBC encryption with Key2 (output->normal register)
*******************************************************/
void de_CBCenc_K2(void)
{
    *p_de64n_ENC_K2 = 0x00000000;
}

/******************************************************
DES-CBC decryption with Key2 (output->normal register)
*******************************************************/
void de_CBCdec_K2(void)
{
    *p_de64n_DEC_K2 = 0x00000000;
}

/******************************************************
Read status of DES (64bits)
*******************************************************/
void de64_Read_Status_des(void* pOutData)
{
    ((uint32_t *)pOutData)[0] = *p_de64n_STATUS_DES1;
    ((uint32_t *)pOutData)[1] = *p_de64n_STATUS_DES0;
}

