/* 2013-07-22: File added and changed by Sony Corporation */
/*
 * Copyright 2013 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#ifndef _DES64_HAL_H
#define _DES64_HAL_H

/*==============================================================
         DES64 Functions
==============================================================*/

/******************************************************
Initialize DES
<input>  ---
<output> ---
<return> void
*******************************************************/
void de_Init_Des(void);

/******************************************************
Write 64bits of data into normal register
<input>  Input Data (64bits)
<output> ---
<return> void
*******************************************************/
void de64_Write_Idata(const void* pInData);

/******************************************************
Set IV / Set Key for unwrap
<input>  IV / Key (64bits)
<output> ---
<return> void
*******************************************************/
void de64_Set_Iv(const void* pInData);

/******************************************************
Set Key2 for DES-CBC
<input>  ---
<output> ---
<return> void
*******************************************************/
void de_Set_K2(void);

/******************************************************
DES-CBC encryption with Key2 (output->normal register)
<input>  ---
<output> ---
<return> void
*******************************************************/
void de_CBCenc_K2(void);

/******************************************************
DES-CBC decryption with Key2 (output->normal register)
<input>  ---
<output> ---
<return> void
*******************************************************/
void de_CBCdec_K2(void);

/******************************************************
Read status of DES (64bits)
<input>  ---
<output> status of DES (64bits)
<return> void
*******************************************************/
void de64_Read_Status_des(void* pOutData);

#endif // _DES64_HAL_H
