/* 2013-05-29: File added by Sony Corporation */
/*
 * Copyright 2013 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#ifndef _MWC_CMD_H
#define _MWC_CMD_H

/*==============================================================
         Parameter definitions
==============================================================*/
/*------ Internal macro command (argument of mwcn_IN_COMMAND) ------*/
#define cReadDramToA	(0x01 << 26)
#define cSetK16C		(0x02 << 26)
#define cCopyAC			(0x03 << 26)
#define cCalcLengthA	(0x04 << 26)
#define cInvHeadId		(0x05 << 26)
#define cCalcNK			(0x06 << 26)
#define cAddSubABC		(0x07 << 26)
#define cIncDecA		(0x08 << 26)
#define cMpyABC			(0x09 << 26)
#define cMpyK16AC		(0x0A << 26)
#define cSetKmpyNA		(0x0B << 26)
#define cSetBbuf		(0x0C << 26)
#define cCompAB			(0x0E << 26)
#define cMpyAddSub		(0x0F << 26)

#define cClearStatus	(0x10 << 26)
#define cSetDone		(0x11 << 26)
#define cSetBaseWord6	(0x12 << 26)
#define cSetWord2		(0x13 << 26)
#define cCheck4Modulo	(0x14 << 26)
#define cSetIdHead		(0x15 << 26)
#define cSetIdHead2		(0x16 << 26)
#define cCopyIdHead		(0x17 << 26)
#define cSetIdExp		(0x18 << 26)
#define cSetCnt32		(0x19 << 26)
#define cCnt32Down		(0x1A << 26)
#define cExpCntDown		(0x1B << 26)
#define cCopyPtNumS0AC	(0x1C << 26)
#define cSetFT0			(0x1D << 26)
#define cCopyFlagsT0	(0x1E << 26)
#define cCopyFlagsT1	(0x1F << 26)
#define cSetSighA		(0x24 << 26)
#define cSetFT1			(0x26 << 26)

#define cSetDramAdrK10	(0x2D << 26)
#define cSetDramPtNumL	(0x2E << 26)
#define cSetDramPtNumH	(0x2F << 26)

#define cBranchCc		(0x31 << 26)
#define cCallCc			(0x32 << 26)
#define cReturnCc		(0x33 << 26)
#define cFinish			(0x34 << 26)
#define cClrSP			(0x35 << 26)

#define cClrError		(0x3E << 26)
#define cSetError		(0x3F << 26)

/*------ Internal process (argument of mwcn_START_PCK10) ------*/
#define StartModulo		0x000;
#define StartDevide		0x002;
#define StartExponent	0x004;
#define StartRsaEnc		0x006;
#define StartCrtInit	0x007;
#define StartCrtEnc		0x008;
#define StartEccInit	0x010;
#define StartECDH1		0x011;
#define StartECDH2		0x012;
#define StartECDSAgen1	0x013;
#define StartECDSAgen2	0x014;
#define StartECDSAveri	0x015;


/*------ Internal register number & address for DRAM ------*/
//=======================================
//  For RSA Engine
//=======================================
// for RSA with CRT
#define regP_crt		0x03
#define regQ_crt		0x04
#define regDP_crt		0x05
#define regDQ_crt		0x06
#define regQ1_crt		0x07
#define regQU_crt		0x18
#define regRE_crt		0x19
#define regTM_crt		0x1A
#define regEX_crt		0x1B
#define regMO_crt		0x1C
#define regTW1_crt		0x1D
#define regMW_crt		0x1E
#define regRW_crt		0x1F
#define addrP_crt		0x020
#define addrQ_crt		0x040
#define addrDP_crt		0x060
#define addrDQ_crt		0x080
#define addrQ1_crt		0x0A0
#define addrQU_crt		0x0C0
#define addrRE_crt		0x0E0
#define addrTM_crt		0x100
#define addrTW1n_crt	0x240
#define addrTW1s_crt	0x120
#define addrMW_crt		0x160
#define addrRW_crt		0x200

// for RSA
#define regN_rsa		0x00
#define regE_rsa		0x01
#define regRE_rsa		0x19
#define regTM_rsa		0x1A
#define regEX_rsa		0x1B
#define regMO_rsa		0x1C
#define regMW_rsa		0x1E
#define regRW_rsa		0x1F
#define addrN_rsa		0x200
#define addrE_rsa		0x240
#define addrRE_rsa		0x280
#define addrTM_rsa		0x2C0
#define addrMW_rsa		0x300
#define addrRW_rsa		0x380

// for A add B
#define regA_add		0x00
#define regB_add		0x01
#define regC_add		0x02
#define addrA_add		0x200
#define addrB_add		0x240
#define addrC_add		0x280

// for A mod B
#define regA_mod		0x1F
#define regB_mod		0x1C
#define regC_mod		0x1F
#define regWork_mod		0x1E
#define addrA_mod		0x200
#define addrWork_mod	0x160

// for A multiply B
#define regA_multi		0x00
#define regB_multi		0x01
#define regC_multi		0x1F
#define addrA_multi		0x280
#define addrB_multi		0x2C0
#define addrC_multi		0x200

// for inverse A
#define regA_inv		0x17
#define regB_inv		0x16
#define regWork0_inv	0x14
#define regWork1_inv	0x15
#define regWork2_inv	0x13
#define regWork3_inv	0x1F
#define regWork4_inv	0x18
#define regWork5_inv	0x19
#define regWork6_inv	0x1A
#define regWork7_inv	0x1C
#define regWork8_inv	0x1E
#define addrA_inv		0x2C0
#define addrB_inv		0x280
#define addrWork0_inv	0x200
#define addrWork1_inv	0x240
#define addrWork2_inv	0x300
#define addrWork3_inv	0x100
#define addrWork4_inv	0x040
#define addrWork5_inv	0x080
#define addrWork6_inv	0x0C0
//#define addrWork7_inv	0x
#define addrWork8_inv	0x180

//=======================================
//  For ECC Engine
//=======================================
// for ECC common
#define regS1_ecc		0x00
#define regS2_ecc		0x01
#define regGx_ecc		0x02
#define regGy_ecc		0x03
#define regKa_ecc		0x04
#define regKb_ecc		0x05
#define regP_ecc		0x06
#define regR_ecc		0x07
#define regWx_ecc		0x08
#define regWy_ecc		0x09
#define regHush_ecc		0x0B
#define regCD_ecc		0x0C
#define regAx_ecc		0x0D
#define regAy_ecc		0x0E
#define regAz_ecc		0x0F
#define regBx_ecc		0x10
#define regBy_ecc		0x11
#define regBz_ecc		0x12
#define regTM0_ecc		0x13
#define regA1_ecc		0x14
#define regA2_ecc		0x15
#define regB1_ecc		0x16
#define regB2_ecc		0x17
#define regQU_ecc		0x18
#define regRE_ecc		0x19
#define regTM_ecc		0x1A
#define regEX_ecc		0x1B
#define regMO_ecc		0x1C
#define regMW_ecc		0x1E
#define regRW_ecc		0x1F
#define addrS1_ecc		0x020
#define addrS2_ecc		0x028
#define addrGx_ecc		0x200
#define addrGy_ecc		0x208
#define addrKa_ecc		0x210
#define addrKb_ecc		0x218
#define addrP_ecc		0x220
#define addrR_ecc		0x228
#define addrWx_ecc		0x230
#define addrWy_ecc		0x238
#define addrHush_ecc	0x248
#define addrCD_ecc		0x250
#define addrAxn_ecc		0x258
#define addrAyn_ecc		0x260
#define addrAz_ecc		0x268
#define addrBx_ecc		0x270
#define addrBy_ecc		0x278
#define addrBz_ecc		0x280
#define addrTM0_ecc		0x360
#define addrA1_ecc		0x370
#define addrA2_ecc		0x378
#define addrB1_ecc		0x380
#define addrB2_ecc		0x388
#define addrQU_ecc		0x390
#define addrRE_ecc		0x398
#define addrTM_ecc		0x3A0
//#define addrEX_ecc	---
//#define addrMO_ecc	---
#define addrMW_ecc		0x3D0
#define addrRW_ecc		0x3C0

// for ECDH1 (Public Key : W = sG)
// input
#define regS_ecdh1		0x1F
#define addrS_ecdh1		0x3C0
// output
#define regWx_ecdh1		0x0D
#define regWy_ecdh1		0x0E
#define addrWxn_ecdh1	0x258
#define addrWyn_ecdh1	0x260

// for ECDH2 (Common Key : Z = sX = tW)
// input
#define regS_ecdh2		0x1F
#define addrS_ecdh2		0x3C0
#define regWx_ecdh2		0x08
#define regWy_ecdh2		0x09
#define addrWx_ecdh2	0x230
#define addrWy_ecdh2	0x238
// output
#define regZx_ecdh2		0x0D
#define regZy_ecdh2		0x0E
#define addrZxn_ecdh2	0x258
#define addrZyn_ecdh2	0x260

// for ECDSA Generate (Signature : (C, D))
// input
#define regS_ecdsagen		0x1F
#define regU_ecdsagen		0x1F
#define regHUSH_ecdsagen	0x0B
#define addrS_ecdsagen		0x3C0
#define addrU_ecdsagen		0x3C0
#define addrHUSH_ecdsagen	0x248
// output
#define regD_ecdsagen		0x0C
#define regC_ecdsagen		0x0D
#define addrD_ecdsagen		0x250
#define addrC_ecdsagen		0x258

// for ECDSA Verify (Signature : C')
// input
#define regC_ecdsavrf		0x0C
#define regD_ecdsavrf		0x17
#define regWx_ecdsavrf		0x08
#define regWy_ecdsavrf		0x09
#define regHUSH_ecdsavrf	0x0B
#define addrC_ecdsavrf		0x250
#define addrD_ecdsavrf		0x388
#define addrWx_ecdsavrf		0x230
#define addrWy_ecdsavrf		0x238
#define addrHUSH_ecdsavrf	0x248
// output
#define regCC_ecdsavrf		0x0D
#define regCdiff_ecdsavrf	0x0F
#define addrCC_ecdsavrf		0x258
#define addrCdiff_ecdsavrf	0x268


#endif // _MWC_CMD_H
