/* 2013-05-29: File added by Sony Corporation */
/*
 * Copyright 2013 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#ifndef _XCRYPTO_ADDR_H
#define _XCRYPTO_ADDR_H

#include "xcrypto_cmd.h"

#include <linux/module.h>
extern void __iomem *xcrypto_ioaddr;
#define XCRYPTO_Base xcrypto_ioaddr

#if 0   // for user space dubugging.
extern volatile void *g_xcrypto_map;
#define XCRYPTO_Base g_xcrypto_map
#else
#ifndef XCRYPTO_Base
#define XCRYPTO_Base (0x38100000)    /* for CXD4135GG(ALLION) */
#endif
#endif


/*---------------------------------------------------
   Bus Bridge
---------------------------------------------------*/
#define	p_bb_IRQ_STS				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQ_STS << 2))
#define	p_bb_IRQEN_NML				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQEN_NML << 2))
#define	p_bb_IRQEN_ERR				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQEN_ERR << 2))
#define	p_bb_IRQEN_DMA				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQEN_DMA << 2))
#define	p_bb_IRQSTS_NML				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQSTS_NML << 2))
#define	p_bb_IRQSTS_ERR				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQSTS_ERR << 2))
#define	p_bb_IRQSTS_DMA				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQSTS_DMA << 2))
#define	p_bb_IRQCLR_NML				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQCLR_NML << 2))
#define	p_bb_IRQCLR_ERR				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQCLR_ERR << 2))
#define	p_bb_IRQCLR_DMA				(volatile uint32_t *)(XCRYPTO_Base + (bb_IRQCLR_DMA << 2))
#define	p_bb_DMA_CTRL				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_CTRL << 2))
#define	p_bb_DMA_CNT				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_CNT << 2))
#define	p_bb_DMA_CMD				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_CMD << 2))
#define	p_bb_DMA_WADR				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_WADR << 2))
#define	p_bb_DMA_RADR				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_RADR << 2))
#define	p_bb_DMA_SWAIT				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_SWAIT << 2))
#define p_bb_DMA_DAT				(volatile uint32_t *)(XCRYPTO_Base + (bb_DMA_DAT << 2))
#define	p_bb_CLK_CTRL				(volatile uint32_t *)(XCRYPTO_Base + (bb_CLK_CTRL << 2))
#define	p_bb_DSWAP_CTRL				(volatile uint32_t *)(XCRYPTO_Base + (bb_DSWAP_CTRL << 2))

/*---------------------------------------------------
   Secure Controller
---------------------------------------------------*/
#define	p_sc_VERSION				(volatile uint32_t *)(XCRYPTO_Base + (sc_VERSION << 2))
#define	p_sc_CONFIG					(volatile uint32_t *)(XCRYPTO_Base + (sc_CONFIG << 2))
#define	p_sc_ALL_CLR				(volatile uint32_t *)(XCRYPTO_Base + (sc_ALL_CLR << 2))
#define	p_sc_DAT_TRN				(volatile uint32_t *)(XCRYPTO_Base + (sc_DAT_TRN << 2))
#define	p_sc_DAT_TRN_XOR			(volatile uint32_t *)(XCRYPTO_Base + (sc_DAT_TRN_XOR << 2))
#define	p_sc_XOR_DATA				(volatile uint32_t *)(XCRYPTO_Base + (sc_XOR_DATA << 2))

/*---------------------------------------------------
    Multi Word Calculator (RSA / ECC)
---------------------------------------------------*/
// Normal Register
#define	p_mwcn_READ_VERSION			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_READ_VERSION << 2))
#define	p_mwcn_IN_COMMAND			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_IN_COMMAND << 2))
#define	p_mwcn_READ_DE_REQ			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_READ_DE_REQ << 2))
#define	p_mwcn_READ_DE_ENR			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_READ_DE_ENR << 2))
#define	p_mwcn_NOR_READ_PTUP		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_NOR_READ_PTUP << 2))
#define	p_mwcn_NOR_READ_PTDN		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_NOR_READ_PTDN << 2))
#define	p_mwcn_READ_IRAM_PTUP		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_READ_IRAM_PTUP << 2))
#define	p_mwcn_READ_IRAM_PTDN		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_READ_IRAM_PTDN << 2))
#define	p_mwcn_SET_DE_REQ			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_DE_REQ << 2))
#define	p_mwcn_SET_DE_ENR			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_DE_ENR << 2))
#define	p_mwcn_SET_DRAM_PTK10		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_DRAM_PTK10 << 2))
#define	p_mwcn_NOR_SET_PTUP			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_NOR_SET_PTUP << 2))
#define	p_mwcn_NOR_SET_PTDN			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_NOR_SET_PTDN << 2))
#define	p_mwcn_SET_IRAM_PTK10		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_IRAM_PTK10 << 2))
#define	p_mwcn_SET_IRAM_PTUP		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_IRAM_PTUP << 2))
#define	p_mwcn_SET_IRAM_PTDN		(volatile uint32_t *)(XCRYPTO_Base + (mwcn_SET_IRAM_PTDN << 2))
#define	p_mwcn_START_PCK10			(volatile uint32_t *)(XCRYPTO_Base + (mwcn_START_PCK10 << 2))
// Secure Register
#define	p_mwcs_SEC_READ_PTUP		(volatile uint32_t *)(XCRYPTO_Base + (mwcs_SEC_READ_PTUP << 2))
#define	p_mwcs_SEC_READ_PTDN		(volatile uint32_t *)(XCRYPTO_Base + (mwcs_SEC_READ_PTDN << 2))
#define	p_mwcs_SEC_SET_PTUP			(volatile uint32_t *)(XCRYPTO_Base + (mwcs_SEC_SET_PTUP << 2))
#define	p_mwcs_SEC_SET_PTDN			(volatile uint32_t *)(XCRYPTO_Base + (mwcs_SEC_SET_PTDN << 2))

/*---------------------------------------------------
   AES128
---------------------------------------------------*/
// Normal Register
#define	p_a128n_STATUS_AES0			(volatile uint32_t *)(XCRYPTO_Base + (a128n_STATUS_AES0 << 2))
#define	p_a128n_STATUS_AES1			(volatile uint32_t *)(XCRYPTO_Base + (a128n_STATUS_AES1 << 2))
#define	p_a128n_STATUS_AES2			(volatile uint32_t *)(XCRYPTO_Base + (a128n_STATUS_AES2 << 2))
#define	p_a128n_STATUS_AES3			(volatile uint32_t *)(XCRYPTO_Base + (a128n_STATUS_AES3 << 2))
#define	p_a128n_INPUT_DATA0			(volatile uint32_t *)(XCRYPTO_Base + (a128n_INPUT_DATA0 << 2))
#define	p_a128n_INPUT_DATA1			(volatile uint32_t *)(XCRYPTO_Base + (a128n_INPUT_DATA1 << 2))
#define	p_a128n_INPUT_DATA2			(volatile uint32_t *)(XCRYPTO_Base + (a128n_INPUT_DATA2 << 2))
#define	p_a128n_INPUT_DATA3			(volatile uint32_t *)(XCRYPTO_Base + (a128n_INPUT_DATA3 << 2))
#define	p_a128n_INIT_0				(volatile uint32_t *)(XCRYPTO_Base + (a128n_INIT_0 << 2))
#define	p_a128n_SET_CTR				(volatile uint32_t *)(XCRYPTO_Base + (a128n_SET_CTR << 2))
#define	p_a128n_CBCD_0				(volatile uint32_t *)(XCRYPTO_Base + (a128n_CBCD_0 << 2))
#define	p_a128n_CBCE_0				(volatile uint32_t *)(XCRYPTO_Base + (a128n_CBCE_0 << 2))
#define	p_a128n_SET_KE				(volatile uint32_t *)(XCRYPTO_Base + (a128n_SET_KE << 2))
#define	p_a128n_SET_KD				(volatile uint32_t *)(XCRYPTO_Base + (a128n_SET_KD << 2))
#define	p_a128n_SET_IV				(volatile uint32_t *)(XCRYPTO_Base + (a128n_SET_IV << 2))
#define	p_a128n_DEC_K2				(volatile uint32_t *)(XCRYPTO_Base + (a128n_DEC_K2 << 2))
#define	p_a128n_ENC_K2				(volatile uint32_t *)(XCRYPTO_Base + (a128n_ENC_K2 << 2))
#define	p_a128n_CTR_K2				(volatile uint32_t *)(XCRYPTO_Base + (a128n_CTR_K2 << 2))
#define	p_a128n_WRP_K20				(volatile uint32_t *)(XCRYPTO_Base + (a128n_WRP_K20 << 2))
#define	p_a128n_WRP_K21				(volatile uint32_t *)(XCRYPTO_Base + (a128n_WRP_K21 << 2))
#define	p_a128n_WRP_K22				(volatile uint32_t *)(XCRYPTO_Base + (a128n_WRP_K22 << 2))
#define	p_a128n_WRP_K23				(volatile uint32_t *)(XCRYPTO_Base + (a128n_WRP_K23 << 2))
#define	p_a128n_UWP_K21				(volatile uint32_t *)(XCRYPTO_Base + (a128n_UWP_K21 << 2))
#define	p_a128n_UWP_K22				(volatile uint32_t *)(XCRYPTO_Base + (a128n_UWP_K22 << 2))
#define	p_a128n_UWP_K23				(volatile uint32_t *)(XCRYPTO_Base + (a128n_UWP_K23 << 2))
#define	p_a128n_UWP_K24				(volatile uint32_t *)(XCRYPTO_Base + (a128n_UWP_K24 << 2))
#define	p_a128n_WRP_K25				(volatile uint32_t *)(XCRYPTO_Base + (a128n_WRP_K25 << 2))
#define	p_a128n_CHK_IV				(volatile uint32_t *)(XCRYPTO_Base + (a128n_CHK_IV << 2))
#define	p_a128n_EECB_K2				(volatile uint32_t *)(XCRYPTO_Base + (a128n_EECB_K2 << 2))
#define	p_a128n_DECB_K2				(volatile uint32_t *)(XCRYPTO_Base + (a128n_DECB_K2 << 2))

/*---------------------------------------------------
   DES64
---------------------------------------------------*/
#define	p_de64n_STATUS_DES0			(volatile uint32_t *)(XCRYPTO_Base + (de64n_STATUS_DES0 << 2))
#define	p_de64n_STATUS_DES1			(volatile uint32_t *)(XCRYPTO_Base + (de64n_STATUS_DES1 << 2))
#define	p_de64n_INPUT_DATA0			(volatile uint32_t *)(XCRYPTO_Base + (de64n_INPUT_DATA0 << 2))
#define	p_de64n_INPUT_DATA1			(volatile uint32_t *)(XCRYPTO_Base + (de64n_INPUT_DATA1 << 2))
#define	p_de64n_INIT_0				(volatile uint32_t *)(XCRYPTO_Base + (de64n_INIT_0 << 2))
#define	p_de64n_SET_K2				(volatile uint32_t *)(XCRYPTO_Base + (de64n_SET_K2 << 2))
#define	p_de64n_SET_IV				(volatile uint32_t *)(XCRYPTO_Base + (de64n_SET_IV << 2))
#define	p_de64n_DEC_K2				(volatile uint32_t *)(XCRYPTO_Base + (de64n_DEC_K2 << 2))
#define	p_de64n_ENC_K2				(volatile uint32_t *)(XCRYPTO_Base + (de64n_ENC_K2 << 2))

/*---------------------------------------------------
   SHA1
---------------------------------------------------*/
// Normal Register
#define	p_s1n_INIT_SHA1				(volatile uint32_t *)(XCRYPTO_Base + (s1n_INIT_SHA1 << 2))
#define	p_s1n_SEND_DATA				(volatile uint32_t *)(XCRYPTO_Base + (s1n_SEND_DATA << 2))
#define	p_s1n_SEND_LDATA1			(volatile uint32_t *)(XCRYPTO_Base + (s1n_SEND_LDATA1 << 2))
#define	p_s1n_SEND_LDATA2			(volatile uint32_t *)(XCRYPTO_Base + (s1n_SEND_LDATA2 << 2))
#define	p_s1n_SEND_LDATA3			(volatile uint32_t *)(XCRYPTO_Base + (s1n_SEND_LDATA3 << 2))
#define	p_s1n_SEND_LDATA4			(volatile uint32_t *)(XCRYPTO_Base + (s1n_SEND_LDATA4 << 2))
#define	p_s1n_NOR_OUT0				(volatile uint32_t *)(XCRYPTO_Base + (s1n_NOR_OUT0 << 2))
#define	p_s1n_NOR_OUT1				(volatile uint32_t *)(XCRYPTO_Base + (s1n_NOR_OUT1 << 2))
#define	p_s1n_NOR_OUT2				(volatile uint32_t *)(XCRYPTO_Base + (s1n_NOR_OUT2 << 2))
#define	p_s1n_NOR_OUT3				(volatile uint32_t *)(XCRYPTO_Base + (s1n_NOR_OUT3 << 2))
#define	p_s1n_NOR_OUT4				(volatile uint32_t *)(XCRYPTO_Base + (s1n_NOR_OUT4 << 2))

/*---------------------------------------------------
   SHA256
---------------------------------------------------*/
// Normal Register
#define	p_s2n_INIT_SHA256			(volatile uint32_t *)(XCRYPTO_Base + (s2n_INIT_SHA256 << 2))
#define	p_s2n_SEND_DATA				(volatile uint32_t *)(XCRYPTO_Base + (s2n_SEND_DATA << 2))
#define	p_s2n_SEND_LDATA1			(volatile uint32_t *)(XCRYPTO_Base + (s2n_SEND_LDATA1 << 2))
#define	p_s2n_SEND_LDATA2			(volatile uint32_t *)(XCRYPTO_Base + (s2n_SEND_LDATA2 << 2))
#define	p_s2n_SEND_LDATA3			(volatile uint32_t *)(XCRYPTO_Base + (s2n_SEND_LDATA3 << 2))
#define	p_s2n_SEND_LDATA4			(volatile uint32_t *)(XCRYPTO_Base + (s2n_SEND_LDATA4 << 2))
#define	p_s2n_NOR_OUT0				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT0 << 2))
#define	p_s2n_NOR_OUT1				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT1 << 2))
#define	p_s2n_NOR_OUT2				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT2 << 2))
#define	p_s2n_NOR_OUT3				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT3 << 2))
#define	p_s2n_NOR_OUT4				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT4 << 2))
#define	p_s2n_NOR_OUT5				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT5 << 2))
#define	p_s2n_NOR_OUT6				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT6 << 2))
#define	p_s2n_NOR_OUT7				(volatile uint32_t *)(XCRYPTO_Base + (s2n_NOR_OUT7 << 2))


#endif // _XCRYPTO_ADDR_H
