/* 2013-05-27: File added and changed by Sony Corporation */
/*
 * Copyright 2013 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Suite 500, Boston, MA 02110-1335 USA.
 *
 */

#ifndef XCRYPTO_AES128_H
#define XCRYPTO_AES128_H

/* state */
#define XCRYPTO_AES128_STATE_ALG_MASK           (0x000000FFUL)

/* algorithm */
#define XCRYPTO_AES128_ALG_TYPE_ECB_ENC         (2)  /* ECB  Encrypt */
#define XCRYPTO_AES128_ALG_TYPE_ECB_DEC         (3)  /* ECB  Decrypt */
#define XCRYPTO_AES128_ALG_TYPE_CBC_ENC         (4)  /* CBC  Encrypt */
#define XCRYPTO_AES128_ALG_TYPE_CBC_DEC         (5)  /* CBC  Decrypt */
#define XCRYPTO_AES128_ALG_TYPE_CTR             (6)  /* CTR  Encrypt/Decrypt */

#define XCRYPTO_AES128_ALG_TYPE_ENC             (0)
#define XCRYPTO_AES128_ALG_TYPE_DEC             (1)

extern struct xcrypto_cipher_ops aescbc128_enc_ops;
extern struct xcrypto_cipher_ops aescbc128_dec_ops;

#endif   /* XCRYPTO_AES128_H */
