/* 2013-07-05: File added by Sony Corporation */
/*
 *  drivers/mmc/host/emxx_sdx_timer.h
 *
 *  Copyright 2013 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef EMXX_SDX_TIMER_H
#define EMXX_SDX_TIMER_H

#define	EMXX_IS_DISCARD_RQ(cmd)		((cmd)->opcode == MMC_ERASE)

/*
 * Timeout for timer is set enough value compared to maximum timeout
 * of host controller
 */
#define EMXX_SDX_TIMER_TIMEOUT		6000

static inline void
emxx_sdx_start_timer(struct timer_list *timer)
{
	timer->expires = jiffies + HZ * EMXX_SDX_TIMER_TIMEOUT / 1000;
	add_timer(timer);
}

static inline void
emxx_sdx_stop_timer(struct timer_list *timer)
{
	int ret;

	ret = del_timer(timer);
	if (ret < 0) {
		printk(KERN_ERR "Failed to del_timer() (ret=%d)\n", ret);
	}
}

static inline void
emxx_sdx_init_timer(struct timer_list *timer, void (*func)(unsigned long),
		    unsigned long data)
{
	init_timer(timer);
	timer->function = func;
	timer->data = data;
}

#endif
