/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2011 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

/* smac_debug.h - header file of smac_debug.c  */

#ifndef __SMAC_DEBUG_H__
#define __SMAC_DEBUG_H__

/* debug print */
#ifdef CONFIG_SMAC_PRINT_RX_SOCKET
void smac_print_rx_skb(struct sk_buff *skb, uint32_t length);
#else
#define smac_print_rx_skb(a,b)		do {} while (0)
#endif

#ifdef CONFIG_SMAC_PRINT_TX_SOCKET
void smac_print_tx_skb(struct sk_buff *skb, uint32_t length, uint32_t offset);
#else
#define smac_print_tx_skb(a,b,c)	do {} while (0)
#endif

#ifdef CONFIG_SMAC_PRINT_TX_FRAGMENT
void smac_print_tx_fragment(struct skb_frag_struct *frag, uint32_t length, uint32_t offset);
#else
#define smac_print_tx_fragment(a,b,c)	do {} while (0)
#endif

#ifdef CONFIG_SMAC_PRINT_MAC_ADDRES
void smac_print_mac_address(int i);
void smac_print_mac_addresses(void);
#else
#define smac_print_mac_address(i)	do {} while (0)
#define smac_print_mac_addresses()	do {} while (0)
#endif

#ifdef CONFIG_SMAC_DEBUG
void __devinit smac_print_options(struct smac_adapter *adapter);
#else
#define smac_print_options(a)		do {} while (0)
#endif

#endif /* __SMAC_DEBUG_H__ */

