/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2008-2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

/* smac_phy_vendor.h - header file of smac_phy_vendor.c */

#ifndef __SMAC_PHY_VENDOR_H__
#define __SMAC_PHY_VENDOR_H__

struct smac_adapter;
struct smac_phy_ops;

void smac_marvell_phy_setup(struct smac_phy_ops *phy_ops);
void smac_micrel_phy_setup(struct smac_phy_ops *phy_ops);

int smac_phy_vendor_init(struct smac_adapter *adapter);
void smac_get_speed_and_duplex(struct smac_adapter *adapter, uint16_t *speed, uint16_t *duplex);
bool smac_link_is_up(struct smac_adapter *adapter);
void smac_assert_crs(struct smac_adapter *adapter);
bool smac_restart_autoneg(struct smac_adapter *adapter);
bool smac_set_force_speed_duplex(struct smac_adapter *adapter);
bool smac_phy_is_mdix(struct smac_adapter *adapter);
bool smac_phy_set_mdix(struct smac_adapter *adapter);

#endif /* __SMAC_PHY_VENDOR_H__ */

