/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2008-2010 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */
#ifndef I2C_ALGO_I2C00_H
#define I2C_ALGO_I2C00_H 1

#include <linux/i2c.h>

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */

#define I2C_HW_I2C00            0x00

#ifdef __KERNEL__
struct i2c_algo_i2c00_data {
	void *data;     /* private data for lolevel routines    */
	void (*setreg) (void *data, int regno, int val);
	int  (*getreg) (void *data, int regno);
	int  (*waitdone) (void *data);
	void (*softreset) (void *data);

	unsigned short slaveaddr;
	spinlock_t		lock;
};

void i2c00_init(struct i2c_algo_i2c00_data *);
int i2c00_reset(struct i2c_algo_i2c00_data *, unsigned long);
int i2c00_ma_ext(struct i2c_algo_i2c00_data *);

int i2c_i2c00_add_bus(struct i2c_adapter *);
int i2c_i2c00_del_bus(struct i2c_adapter *);

#endif /* __KERNEL__ */

struct i2c_i2c00_slave {
	unsigned long  index;
	char           data;
	int            flag;
};

#define I2C_I2C00_SLAVE_ACK     0x00
#define I2C_I2C00_SLAVE_NACK    0x01

#ifdef __cplusplus
}       /* extern "C" */
#endif  /* __cplusplus */

#endif /* I2C_ALGO_I2C00_H */
