/* 2011-11-02: File added and changed by Sony Corporation */
/*
 *  Copyright 2011 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

/* smac-xarina_platform.h - platform data declarations for the drivers/net/smac-xarina */

#ifndef __LINUX_SMAC_PLATFORM_H
#define __LINUX_SMAC_PLATFORM_H

#include <linux/phy.h>

/* PHY vendor */
enum smac_phy_vendor {
	SMAC_MICREL_KSZ8051MNL,	/* Micrel KSZ8051MNL PHY (Fast Ethernet) */
	SMAC_MARVELL_88E1111, 	/* Marvell 88E1111 PHY (Gigabit Ethernet) */
};


/* platform data for SMAC driver */
struct smac_platform_data {
	u8 phy_addr;			/* PHY Layer Address */
	phy_interface_t phy_if;		/* PHY interface type */

	/* PHY MDC Clock Range */
	/* MCR | AHB clock (MHz)
	  -----+----------------
	   000 | 60-100
	   001 | 100-150
	   010 | 20-35
	   011 | 35-60
	   100 | 150-250
	   101 | 250-300
	 */
	u8 mcr;

	u8 burst_length;		/* burst length : (1,4,8,16) */
	enum smac_phy_vendor phy_vendor;
};

#endif /* __LINUX_SMAC_PLATFORM_H */
